#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

new STRING_VERSION[MAX_DATA_LENGTH] = "04.02.03";

#define BUNNYALLOFF 	0
#define BUNNYALLON	1
#define BUNNYTEAMTERR	2
#define BUNNYTEAMCT	3

#define CHATSAY		0
#define TSAY		1
#define CSAY		2

/*definiert, wie lange es dauert, bis der nchste Sprung gemacht wird. Default: 1*/
#define HOPTIME		1

new BunnyHop[MAX_PLAYERS];
new iTimer[MAX_PLAYERS];

public plugin_init() {
	plugin_registerinfo("SDAL-BUNNYHOP","Forces player to behave like a bunny",STRING_VERSION);
	plugin_registercmd("admin_bunnyall","admin_bunny",ACCESS_BAN,"admin_bunnyall: Forces all players to make duck-jumps");
	plugin_registercmd("admin_bunnyall_off","admin_bunny",ACCESS_BAN,"admin_bunnyall_off: Turns off duck-jumps for all players");
	plugin_registercmd("admin_bunny","admin_bunny",ACCESS_BAN,"admin_bunny: 'Target': Forces player to make duck-jumps");
	plugin_registercmd("admin_bunny_off","admin_bunny",ACCESS_BAN,"admin_bunny_off 'Target': 'Target': Turns off duck-jumps for the player");
	plugin_registercmd("admin_bunny_t","admin_bunny",ACCESS_BAN,"admin_bunny_t : Forces all Terrors to make duck-jumps");
	plugin_registercmd("admin_bunny_ct","admin_bunny",ACCESS_BAN,"admin_bunny_ct : Forces all Counters to make duck-jumps");
	
	return PLUGIN_CONTINUE;
}

public admin_bunny(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new Player[MAX_NAME_LENGTH];
	new TargetName[MAX_NAME_LENGTH];
	new iUID;
	
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Player,MAX_NAME_LENGTH);
	
	
	if(strcmp(Command,"admin_bunnyall")==0){
		bunny_all(BUNNYALLON);
		snprintf(Text,MAX_TEXT_LENGTH," BUNNY MODE ON!^n Everybody becomes a bunny!^n Chase has begun!");
		display_console("Everybody is turned into a bunny!");
		display_all(Text,CSAY);
		display_all(Text,CHATSAY);
	}else if(strcmp(Command,"admin_bunnyall_off")==0){
		bunny_all(BUNNYALLOFF);
		snprintf(Text,MAX_TEXT_LENGTH," BUNNY MODE OFF!^n Everybody can move normal!^n Chase is over!");
		display_console("All bunnys are dead now!");
		display_all(Text,CSAY);
		display_all(Text,CHATSAY);
	}else if(strcmp(Command,"admin_bunny_ct")==0){
			bunny_all(BUNNYTEAMCT);
			display_console("All CTs are bunnys now!");
			snprintf(Text,MAX_TEXT_LENGTH," STRANGE!^n Every Counter behave like a bunny!^n Terrors, let the chase beginn!");
			display_all(Text,CSAY);
			display_all(Text,CHATSAY);
	}else if(strcmp(Command,"admin_bunny_t")==0){
			bunny_all(BUNNYTEAMTERR);
			display_console("All Terrors are bunnys now!");
			snprintf(Text,MAX_TEXT_LENGTH," STRANGE!^n Every Terror behave like a bunny!^n Counters, let the chase beginn!");
			display_all(Text,CSAY);
			display_all(Text,CHATSAY);
	}else if(strcmp(Command,"admin_bunny")==0){
		iUID=check_player(Player,TargetName);
		if(iUID!=0){
			if(BunnyHop[iUID]!=1){				
				snprintf(Text,MAX_TEXT_LENGTH,"%s is a bunny now!",TargetName);
				display_console(Text);
				snprintf(Text,MAX_TEXT_LENGTH," %s:^n I am a bunny!^n Try to catch me!",TargetName);
				display_all(Text,TSAY);
				display_all(Text,CHATSAY);
				bunny_on(iUID);
			}else{
				snprintf(Text,MAX_TEXT_LENGTH,"%s is already turned into a bunny!",TargetName);
				display_console(Text);
			}
		}
	}else if(strcmp(Command,"admin_bunny_off")==0){
		get_username(Player,TargetName,MAX_NAME_LENGTH);
		get_userindex(TargetName,iUID);
		if(BunnyHop[iUID]==1){
			snprintf(Text,MAX_TEXT_LENGTH,"%s stops to be bunny!",TargetName);
			display_console(Text);
			snprintf(Text,MAX_TEXT_LENGTH," %s^n is not a bunny anymore!^n Chase is over!",TargetName);
			display_all(Text,TSAY);
			display_all(Text,CHATSAY);
			bunny_off(iUID);
		}else{
			snprintf(Text,MAX_TEXT_LENGTH,"%s is not turned into a bunny!",TargetName);
			display_console(Text);
		}
	}
		
	return PLUGIN_HANDLED;
}

check_player(Player[],TargetName[]){
	new Authid[MAX_AUTHID_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new iUID=0;
	if (check_user(Player)==1){
		get_userAuthID(Player,Authid,MAX_AUTHID_LENGTH);
		if(strcmp(Authid,"BOT")!=0){
			get_username(Player,TargetName,MAX_NAME_LENGTH);
			if(check_immunity(TargetName)==1) {
				snprintf(Text, MAX_TEXT_LENGTH, "Laf. You can't turn '%s' into a bunny, you silly bear.", TargetName);
				display_console(Text);
			}
			get_userindex(TargetName,iUID);
		}else{
			snprintf(Text, MAX_TEXT_LENGTH, "%s is a BOT! Unable to execclient!", TargetName);
			display_console(Text);
		}
		
	}else{
		display_console("Cant find player with that name!");
	}
	return iUID;
}

bunny_all(status){
	new Player[MAX_NAME_LENGTH];
	new iSID,iWID,iTeam,iDead;
	new Authid[MAX_AUTHID_LENGTH];
	new dummy[MAX_NAME_LENGTH];
	new i;
	new iUID;
	new maxplayers=maxplayercount();
	
	for(i=1;i<=maxplayers;i++){
		if(playerinfo(i,Player,MAX_NAME_LENGTH,iSID,iWID,iTeam,iDead,Authid)){
			switch(status){
				case BUNNYALLOFF:{
					if(BunnyHop[i]!=0){
						bunny_off(i);
					}
				}
				case BUNNYALLON:{
					if(BunnyHop[i]!=1){
						iUID=check_player(Player,dummy);
						if(iUID!=0){
							bunny_on(i);
						}
					}
				}
				case BUNNYTEAMTERR:{
					if(iTeam==1){
						if(BunnyHop[i]!=1){
							iUID=check_player(Player,dummy);
							if(iUID!=0){
								bunny_on(i);
							}
						}
					}
				}
				case BUNNYTEAMCT:{
					if(iTeam==2){
						if(BunnyHop[i]!=1){
							iUID=check_player(Player,dummy);
							if(iUID!=0){
								bunny_on(i);
							}
						}
					}
				}
			}
		}
	}
	return PLUGIN_HANDLED;
}
	

bunny_off(iUID){	
	BunnyHop[iUID]=0;
	if(iTimer[iUID]!=0){
		kill_timer(iTimer[iUID]);
		iTimer[iUID]=0;
	}
	return PLUGIN_HANDLED;
}

bunny_on(iUID){
	BunnyHop[iUID]=1;
	iTimer[iUID]=set_timer("bunnyhop",HOPTIME,99999);
	return PLUGIN_HANDLED;
}

display_all(Text[],iSay){
	if(iSay==0){
		say(Text);
	}else if(iSay==1){
		typesay(Text,15,random(255),random(255),random(255));
	}else{
		centersay(Text,15,random(255),random(255),random(255));
	}
	return PLUGIN_HANDLED;
}

display_console(Text1[]){
	selfmessage("--SDAL-BUNNYHOP--");
	selfmessage("");
	selfmessage(Text1);
	selfmessage("");
	selfmessage("------------------");
	return PLUGIN_HANDLED;
}
	
public bunnyhop(Timer,Repeat,HLName,HLParam) {
	new Text[MAX_TEXT_LENGTH];
	new Target[MAX_NAME_LENGTH];
	new iSID,iWID,iTeam,iDead;
	new Authid[MAX_AUTHID_LENGTH];
	new i;
	new maxplayers=maxplayercount();
	for(i=1;i<=maxplayers;i++){
		if(playerinfo(i,Target,MAX_NAME_LENGTH,iSID,iWID,iTeam,iDead,Authid)){
			if(BunnyHop[i]==1){
				if(iDead!=1){
					execclient(Target,"+jump; wait; +duck; -jump; slot10");
					execclient(Target,"-duck");
				}else{
					snprintf(Text,MAX_TEXT_LENGTH," %s^n is caught and not^n a bunny anylonger!",Target);
					display_all(Text,TSAY);
					display_all(Text,CHATSAY);
					bunny_off(i);
				}
			}
		}
	}
	return PLUGIN_CONTINUE;
}

public plugin_connect(HLUserName,HLIP, UserIndex) {
	bunny_off(UserIndex);
	return PLUGIN_CONTINUE;
}

public plugin_disconnect(HLUserName,UserIndex) {
	bunny_off(UserIndex);
	return PLUGIN_CONTINUE;
}